module NoException
  def self.No(*methods)
    Module.new do
      define_singleton_method(:included) do |klass|
        methods = klass.instance_methods(false) if methods.empty?
        mod = Module.new do
          methods.each do |m|
            define_method m do |*args|
              begin
                return super(*args)
              rescue StandardError => e
                $error = e
                return nil
              end
            end
          end
        end
        klass.prepend mod
      end
    end
  end

  No = self.No()

  def self.Go(*methods)
    Module.new do
      define_singleton_method(:included) do |klass|
        methods = klass.instance_methods(false) if methods.empty?
        mod = Module.new do
          methods.each do |m|
            define_method m do |*args|
              begin
                return super(*args), nil
              rescue StandardError => e
                return nil, e
              end
            end
          end
        end
        klass.prepend mod
      end
    end
  end

  Go = Go()
end
